#ifndef CAMERA_DRIVING_GENERAL_WRAPPER_HEADER_H
#define CAMERA_DRIVING_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "CameraDriving_PubDataWrapper.h"
#include "camera_drv/executable.h"


using namespace jac::ap::cameradrivingservice::skeleton;
using namespace jac::ap::visualization::skeleton;

//PubWrappers
GENERATE_PUB_WRAPPER(CamDrv2Visualization_Provide, CamDrv2Visualization_PubDataWrapper, VisualizationSkeleton, CameraH265Image, CameraH265ImagePDataViz);
GENERATE_PUB_WRAPPER(CamDrv2CamDrvPerception_Provide, CamDrv2CamDrvPerception_PubDataWrapper, CameraDrivingServiceSkeleton, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionOneEvent);
GENERATE_PUB_WRAPPER(CamDrv2CamDrvPerceptionTwo_Provide, CamDrv2CamDrvPerceptionTwo_PubDataWrapper, CameraDrivingServiceSkeleton, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionTwoEvent);
GENERATE_PUB_WRAPPER(CamDrv2CamDrvPerceptionThree_Provide, CamDrv2CamDrvPerceptionThree_PubDataWrapper, CameraDrivingServiceSkeleton, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionThreeEvent);
GENERATE_PUB_WRAPPER(CamDrv2CamDrvPerceptionFour_Provide, CamDrv2CamDrvPerceptionFour_PubDataWrapper, CameraDrivingServiceSkeleton, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionFourEvent);

class GeneralWrapper {
public:
    //Providers
    CamDrv2Visualization_Provide _CamDrv2Visualization_Provide;
    CamDrv2CamDrvPerception_Provide _CamDrv2CamDrvPerception_Provide;
    CamDrv2CamDrvPerceptionTwo_Provide _CamDrv2CamDrvPerceptionTwo_Provide;
    CamDrv2CamDrvPerceptionThree_Provide _CamDrv2CamDrvPerceptionThree_Provide;
    CamDrv2CamDrvPerceptionFour_Provide _CamDrv2CamDrvPerceptionFour_Provide;
    
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
};


#endif
